#include <AccelStepper.h>

#define EnablePin 12
#define IN1 8
#define IN2 9
#define IN3 10
#define IN4 11
#define MotorInterfaceType 4

#include <EEPROM.h>

// EEPROM addresses
#define FOCUSER_POS_START 0
#define STEPPER_SPEED_ADD 3    

AccelStepper stepper(MotorInterfaceType, IN1, IN2, IN3, IN4);

// Global vars
boolean moving = false;
boolean hold = false;
boolean reversed;
boolean positionSaved;               // Flag indicates if stepper position was saved as new focuser position
boolean firstPrint = false;
boolean homeFound = true;
String inputString;                  // Serial input command string (terminated with \n)
boolean findingHome = false;

// *************  this value must be changed for each specific setup ***************************************
long maxSteps = 505960;  // **** steps needed for 2 complete revolutions.  prevent cord wrap.
long minStep = 0;
//  Must also enter this value/720 = steps/degree for first time ASCOM driver setup, click "properties 
// ******************************************************************************************************

int manualMoveStepSize = 50;  //higher number for faster manual moves
int findHomeStepSize = 100; //adjusts finding home speed

int buttonStateCW = HIGH;
int buttonStateCCW = HIGH;
boolean manualMoveCW = false;
boolean manualMoveCCW = false;

int HEState = 0;
long lastDebounceTime = 0;
long debounceDelay = 20;
void loop(){ 
  if (findingHome == true){
   findHome();
  } 

  // Stepper loop
  if (stepper.distanceToGo() == 0){
    if (hold == false){
      analogWrite(EnablePin, HIGH);
    }
  } else{
    analogWrite(EnablePin, 200);
  }
  if (stepper.distanceToGo() == 0 && !positionSaved){
    saveFocuserPos(stepper.currentPosition());
    positionSaved = true;
  }
  if(stepper.distanceToGo() != 0 && !firstPrint) { 
    firstPrint = true;
  }

  if(stepper.distanceToGo() != 0){
    moving = true;
  }else{
    moving = false;
  }
  stepper.run();
}
